<!DOCTYPE html>
<html lang="en">
  <head>
    <title>List users</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </head>
  <body>
    <div class="container">
      <div class="text-center mt-4 mb-3">
        <h2>Danh sách người dùng</h2>
      </div>

      <table
        id="user-table"
        class="table table-bordered table-striped table-hover"
      >
        <thead>
          <tr>
            <td>STT</td>
            <td>Username</td>
            <td>First name</td>
            <td>Last name</td>
            <td>Email</td>
            <td>Age</td>
            <td>Role</td>
            <td>Action</td>
          </tr>
        </thead>
        <tbody></tbody>
      </table>
    </div>
    ​
    <script>
      /***
        * TODO: gán data user vào DataTale, render cột STT và mapping được roleId thành roleName

        *** Gợi ý cho cột STT ***
        * a) sử dụng phương thức render trong cột STT (định nghĩa ở columnDefs);
        * b) khai báo 1 biến toàn cục STT và mỗi lần render thì tăng lên 1

        * *** Gợi ý cho cột role ***
        * a) sử dụng phương thức render trong cột Role (định nghĩa ở columnDefs);
        * b) khai báo 1 hàm từ roleId trả về roleName, và đc gọi hàm này trong phương thức render ở trên
      */

      $(document).ready(function () {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gJsonUser = `{
          "description": "Data user",
          "users": [
          {
            "id": 2,
            "username": "quannv",
            "firstname": "Ngo Van",
            "lastname": "Quan",
            "age": 18,
            "email": "quan@gmail.com",
            "roleId": 5
          },
          {
            "id": 3,
            "username": "longdh",
            "firstname": "Do Hoang",
            "lastname": "Long",
            "age": 19,
            "email": "long@gmail.com",
            "roleId": 8
          },
          {
            "id": 4,
            "username": "hiendt",
            "firstname": "Do Thi",
            "lastname": "Hien",
            "age": 29,
            "email": "hien@gmail.com",
            "roleId": 11
          },
          {
            "id": 6,
            "username": "lanht",
            "firstname": "Ho Thi",
            "lastname": "Lan",
            "age": 27,
            "email": "lan@gmail.com",
            "roleId": 13
          }
        ]
      }`;
        var gJsonRole = `{
          "description": "User Roles",
          "roles": [
            {
              "roleId": 5,
              "roleName": "Admin"
            },
            {
              "roleId": 8,
              "roleName": "Manager"
            },
            {
              "roleId": 11,
              "roleName": "Teacher"
            },
            {
              "roleId": 13,
              "roleName": "Staff"
            }
          ]
        }`;

        var gListUsers = JSON.parse(gJsonUser);
        var gListRoles = JSON.parse(gJsonRole);
        console.log(gListUsers);
        console.log(gListRoles);

        var gNameCol = [
          "id",
          "username",
          "firstname",
          "lastname",
          "age",
          "email",
          "roleId",
          "action",
        ]; //cột điểm sẽ là dữ liệu để tính ra cột xếp hạng
        const gUSER_ID_COL = 0;
        const gUSER_NAME_COL = 1;
        const gFIRST_NAME_COL = 2;
        const gLAST_NAME_COL = 3;
        const gAGE_COL = 4;
        const gEMAIL_COL = 5;
        const gROLE_ID_COL = 6;
        const gACTION_COL = 7;

        var gStt = 0;
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        onPageLoading(); //gọi onpage loading để tạo bảng
        insertDataRowToTable(gListUsers.users);

        $(document).on("click", "#user-table .btn-detail", function () {
          //gán sự kiện xử lý onclick cho các button trong bảng user table, có class là btn-detail
          onBtnDetailClick(this);
        });
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
          /* Hãy đổ dữ liệu vào table và thực hiện nút information (chi tiết)
           * dùng cách khai báo data source ngay từ đầu */
          $("#user-table").DataTable({
            columns: [
              { data: gNameCol[gUSER_ID_COL] },
              { data: gNameCol[gUSER_NAME_COL] },
              { data: gNameCol[gFIRST_NAME_COL] },
              { data: gNameCol[gLAST_NAME_COL] },
              { data: gNameCol[gAGE_COL] },
              { data: gNameCol[gEMAIL_COL] },
              { data: gNameCol[gROLE_ID_COL] },
              { data: gNameCol[gACTION_COL] },
            ],
            columnDefs: [
              //định nghia các cột cần hiện ra
              {
                targets: gUSER_ID_COL, //cột ID
                className: "text-center text-primary",
                render: renderStt,
              },
              {
                targets: gROLE_ID_COL, //cột ID
                className: "text-primary",
                render: renderRoleIdToRoleName,
              },
              {
                targets: gACTION_COL, //cột Action
                className: "text-center",
                defaultContent:
                  "<button class='btn btn-primary btn-detail'> Chi tiết </button>", //nội dung html của cột là nút button, class btn-detail để đánh dấu các nút hiện information
              },
            ],
          });
        }

        function insertDataRowToTable(paramListUser) {
          "use strict";
          var vTable = $("#user-table").DataTable();
          vTable.clear();
          vTable.rows.add(paramListUser);
          vTable.draw();
        }

        function onBtnDetailClick(paramElement) {
          "use strict";
          var vRowClick = $(paramElement).closest("tr"); // Xác định tr chứa nút bấm được click
          var vTable = $("#user-table ").DataTable(); // tạo biện truy xuất đến datatable
          var vDataRow = vTable.row(vRowClick).data(); // Lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
          console.log("user name : " + vDataRow.username);
          console.log("first name : " + vDataRow.firstname);
          console.log("last name : " + vDataRow.lastname);
          console.log("age : " + vDataRow.age);
          console.log("email : " + vDataRow.email);
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //hàm render stt
        function renderStt() {
          gStt++;
          return gStt;
        }

        //hàm render role id to role name
        function renderRoleIdToRoleName(paramRoleId) {
          "use strict";
          var vRoleName = "CHUA_CO_TEN";
          var vFound = false;
          var vViTriHienTai = 0;
          while (!vFound && vViTriHienTai < gListRoles.roles.length) {
            if (gListRoles.roles[vViTriHienTai].roleId === paramRoleId) {
              vRoleName = gListRoles.roles[vViTriHienTai].roleName;
              vFound = true;
            }
            vViTriHienTai++;
          }
          return vRoleName;
        }
      });
    </script>
  </body>
</html>
